// GlobalStuff.cpp: implementation of the CGlobalStuff class.
//
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include "string.h"
#include "StdAfx.h"
#include "GlobalStuff.h"
#include <iostream>
#include "Client.h"
#include "ClientHandler.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CGlobalStuff g;
CGlobalStuff::CGlobalStuff()
{
	serverAdress=0;
	maxPacketTime=0;
}

std::string CGlobalStuff::ParseAdmin (std::string pkt, int id)
{
	std::string inpass;
	std::string aid;
	std::string tempstring;
	std::string retval;

	int admintype;
	int a;
	CClient *c;
	char temp[50];
	
	tempstring = pkt;

	if (tempstring[0] != '0')
		return "";

	//urk fult
	for(a=2;tempstring[a]!=' ' && tempstring[a]!=13;a++)
	inpass+=tempstring[a];
	admintype = atoi (inpass.c_str ());

	for(a=4;tempstring[a]!=' ' && tempstring[a]!=13;a++)
	aid+=tempstring[a];

	inpass = "";
	a++;
	for(;tempstring[a]!=' ' && tempstring[a]!=13;a++)
	inpass+=tempstring[a];

	if (g.adminPass.compare (inpass)==0) {
		switch (admintype) {
		case 1:
			strcpy (temp, "0 1 0\xd\xa");					
			retval = temp;		
			cout << "Correct admin password received from client " << id << endl;
			break;
		case 2:
			a = atoi (aid.c_str ());					
			c = clienthandler->FindClient (a);
			if (c) {
			  sprintf(temp,"0 2 %d\xd\xa",a);					
			  retval = temp;			  
			  cout << "Client " << id << " mutes client " << a << endl;
			  c->muted = true;
			}
			else {
			  sprintf(temp,"0 9 %d\xd\xa",a);					
			  retval = temp;			  
			  cout << "Client " << id << " sends mute request for unknown client " << a << endl;
			}
			break;
		case 3:
			a = atoi (aid.c_str ());					
			c = clienthandler->FindClient (a);
			if (c) {
			  sprintf(temp,"0 3%d\xd\xa",a);					
			  retval = temp;			  
			  cout << "Client " << id << " kicks client " << a << endl;
			  clienthandler->DeleteClient (c);
			  clienthandler->ConnectionNumChange();
			}
			else {
			  sprintf(temp,"0 9 %d\xd\xa",a);					
			  retval = temp;			  
			  cout << "Client " << id << " sends kick request for unknown client " << a << endl;
			}
			break;
		}
	}
	else {
		strcpy(temp, "0 8 0\xd\xa");
		retval = temp;		
		cout << "Received admin call with wrong password (" << inpass << ") from client " << id << endl;
	}

	return retval;
}

unsigned long CGlobalStuff::GetInAddr (const char *addr)
{
	struct  hostent *lpHostEntry;
	unsigned long ul;

	if (addr [0] == 0)
		return INADDR_ANY;

	if((ul=inet_addr(addr))!=-1){
		return ul;

		lpHostEntry = gethostbyaddr((char*)&ul,sizeof(ul),AF_INET); 
		if (lpHostEntry == NULL)
		{
			cout << "Error looking up " << addr << " from ip." << endl;
//			MessageBox(NULL,"Error looking up master server from ip.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			return INADDR_ANY;
		}
	} else {
		lpHostEntry = gethostbyname(addr);
		if (lpHostEntry == NULL)
		{
			cout << "Error looking up " << addr << " from dns." << endl;
//			MessageBox(NULL,"Error looking up master server from dns.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			return INADDR_ANY;
		}
	}

	cout << "Resolving " << addr << "..." << endl;
	return (*((in_addr *)*lpHostEntry->h_addr_list)).s_addr;
}

CGlobalStuff::~CGlobalStuff()
{
	numClients=0;
	numFeeders=0;
	maxClients=0;
	clientPort=28312;
}
